window.dataStore = {};

dataStore = Object.freeze(dataStore);

Object.unfreeze=function(o){
   let oo=undefined;
		if( o instanceof Array){
			oo=[];
			let clone=function(v){oo.push(v)};
			o.forEach(clone);
		}else if(o instanceof String){
			oo=new String(o).toString();
		}else  if(typeof o =='object'){
			oo={};
			for (let property in o){
				oo[property] = o[property];
			}
		}
		return oo;
 }

function create(storeName) {
	dataStore = Object.unfreeze(dataStore);
	dataStore[storeName] = {};
	dataStore = Object.freeze(dataStore);
	return dataStore[storeName];
}

function insert(storeName, object) {
	dataStore = Object.unfreeze(dataStore);
	if (typeof dataStore[storeName] !== 'undefined') {
		dataStore[storeName] = object;
	} else {
		throw storeName + ' is not empty! Use "set" for setting a value';
	}
	dataStore = Object.freeze(dataStore);
	return dataStore[storeName];
}

function list(storeName) {
	return dataStore[storeName];
}

create('test');

insert('test', {
	name: 'ahoj',
	prop: {
		nested: 10
	},
});

console.log(list('test'));